﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="wucExtGrid.ascx.cs"
    Inherits="ExtJsWithWebServiceandDatabase.Controls.wucExtGrid" %>
<link href="../Extjs-Grid/ExtJsScripts/ext-all.css" rel="stylesheet" type="text/css" />
<div id="ext-grid">
</div>
<asp:ScriptManager ID="PageScriptManager" runat="server">
    <Scripts>
        <asp:ScriptReference Path="~/Extjs-Grid/ExtJsScripts/ext-all-debug.js" />
        <asp:ScriptReference Path="~/Extjs-Grid/ExtJsScripts/Ext.ux.AspWebAjaxProxy.js" />
    </Scripts>
</asp:ScriptManager>
<style type="text/css">
    .x-custgrid3-row td
    {
        padding: 5px;
    }
    .x-box-inner .x-column-header-inner
    {
        padding: 5px;
    }
</style>
<script type="text/javascript">
    Ext.require([
            'Ext.grid.*',
            'Ext.data.*',
            'Ext.panel.*',
            'Ext.layout.container.Border'
        ]);
    Ext.onReady(function () {
        Ext.QuickTips.init();

        // setup the state provider, all state information will be saved to a cookie
        Ext.state.Manager.setProvider(Ext.create('Ext.state.CookieProvider'));
        Ext.namespace('EXT');
        Ext.define('Actors', {
            extend: 'Ext.data.Model',
            fields: ['ProductId', 'ProductName', 'ItemNumber', 'CategoryName', 'Price']
        });


        var store = new Ext.data.Store(
            {
                proxy: new Ext.ux.AspWebAjaxProxy({
                    url: '../App_Services/ExtjsWebservice.asmx/LoadRecords',
                    actionMethods: {
                        read: 'POST'
                    },
                    reader: {
                        type: 'json',
                        model: 'Actors',
                        root: 'd'
                    },
                    headers: {
                        'Content-Type': 'application/json; charset=utf-8'
                    }
                })
            });

        // create the grid
        var grid = Ext.create('Ext.grid.Panel', {
            store: store,
            stateful: true,
            stateId: 'stateGrid',
            columns: [
                //{ text: 'Product Id', dataIndex: 'ProductId', renderer: FirstName_Rendered, width: 280, sortable: true },
                { text: 'Product Name', dataIndex: 'ProductName', renderer: ProductName_Rendered, sortable: true },
                { text: 'Item Number', dataIndex: 'ItemNumber',  sortable: true },
                { text: 'Category Name', dataIndex: 'CategoryName', sortable: true },
                { text: 'Price', dataIndex: 'Price', renderer: 'usMoney', sortable: true }
               ],
            ctCls: 'x-custgrid3-row',
            renderTo: 'ext-grid'
        });

        store.load();
    });
</script>
