﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="message-display.ascx.cs" Inherits="Dala.Samples.User_Controls.message_display.message_display" %>
<div id="divMessage" runat="server" style="display:none;">
 <ul id="ulMessage" runat="server" class="color-mass-ul">
 
 </ul>
</div>

<script type="text/javascript">

    //=== Message Display and Message Clear related section =====================
    function DisplayMessage(isError, isInformation) 
    {
        if (isInformation == false) {
            if (isError) {
                $("ul[id*=ulMessage]").addClass("error");
            }
            else {
                $("ul[id*=ulMessage]").addClass("success");
            }
        }
        else {
            $("ul[id*=ulMessage]").addClass("info");
        }

        //Set div style to block to display message     
        $("div[id*=divMessage]").css("display", "block");

    }

    function AppendMessage(message) {

        var formattedMessage = "<li>" + message + "</li>";
        $("ul[id*=ulMessage]").append(formattedMessage);

    }

    function ClearMessage() 
    {
        $("ul[id*=ulMessage]").removeClass("error success info");
        $("ul[id*=ulMessage]").html("");
        $("div[id*=divMessage]").css("display", "none");

    }

    //================ Execute Validation section ====================

    function ExecuteValidation() 
    {

        ClearMessage();
        var isValid = true;

        //--------- Required Field Validation -----------
        $(".dummy-required").each(function () {
            var inputName = $(this).attr("InputName");


            if (ValidateRequiredField($(this), inputName) == false) {
                isValid = false;
            }


        });
        //-------------- If required field validation successfully pass, then check for other validation
        if (isValid) {

            $(".dummy-email").each(function () {
                var inputName = $(this).attr("InputName");

                if (EmailFormatValidation($(this), inputName) == false) {
                    isValid = false;
                }
            });
        }

        //--------- If any vadation error found then display error message
        if (!isValid) {
            DisplayMessage(true, false);
            return false;
        }
        else {
            return true;
        }

    }//end function



    //=== Input Validation  Section ======================

    function EmailFormatValidation(element,inputName) 
    {
        var trimValueEmail = $.trim($(element).val());

        var emailRegEx = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;


        if (!emailRegEx.test(trimValueEmail)) {
            AppendMessage(inputName + " format is not valid.");
            return false;
        }
        else {
            return true;
        }
    }

    function ValidateRequiredField(element,inputName) {

        if ($.trim($(element).val()) == "") 
        {
            AppendMessage(inputName+" is required.");
            return false;
        }
        else 
        {
            return true;
        }
    }
</script>